+++
title = "Links for 2020-04-25"
date = 2020-04-25

[taxonomies]
tags = ["links", "rust", "adoption", "search", "bash", "debug", "apple",
"mocks", "cli", "kanban", "survey", "til"]
+++

Extracting PDF Data, Rust Adoption, Rust Search, Debugging Bash Scripts,
Mocked HTTP Servers in Rust, CLI Kanban, COVID Lockdown, Rust Survey, TIL.

<!-- more -->

# [Indexing PDF For Searching Using Tika, Nokogiri, and Algolia](https://omar.engineer/indexing-pdf-for-searching-using-tika-nokogiri-and-algolia/)

Although I don't use Ruby -- and hence Nokogiri and Algolia would be useless
-- the fact that it lists how Tika extracts the PDF information into a (good)
HTML format it interesting.

# [Debugging Bash scripts](https://advancedweb.hu/debugging-bash-scripts/)

Couple of notes and modules you can use in Bash scripts to debug your...
scripts.

On a side note: Am I the only one that think it is stupid to have a docker
image to run a _linter_?

# [Programming language Rust's adoption problem: Developers reveal why more aren't using it](https://www.zdnet.com/google-amp/article/programming-language-rusts-adoption-problem-developers-reveal-why-more-arent-using-it/)

Summary: the drop in adoption happens 'cause even if developers are using
Rust, their companies are not.

Sadly, I once read something that's true: "The adoption of any language is not
technical, it is cultural". While developers may enjoy taking some punches
from compilers, in the hopes that they won't get calls in the middle of
the night about the service going down, most companies see delays in delivery
as problem. And if some other language have some (apparent) huge support, they
will pick that language any day, no matter how problematic it is.

# [Even Apple Is Interested In Migrating Their C Code To Rust](https://www.phoronix.com/scan.php?page=news_item&px=Apple-From-C-To-Rust)

A lot of assumptions going on here, but it seems that even when Rust adoption
is not that great, big companies are actually moving towards it. Apple is one
of them.

The fact that the creator of Rust is part of Apple and works of Swift may be
pure coincidence.

On the other hand... Why not replace that C code with Swift? Surely there is a
runtime problem here if the applications require performance, but with the
Swift compiler being built by Apple and Clang/LLVM also being built by Apple,
something could be worked out, wouldn't it?

# [Rust Search Extension](https://rust-search-extension.now.sh/)

A browser extension that helps searching Rust Docs and Crates.

Honestly, I prefer [DuckDuckGo](https://duckduckgo.com/)
[!bangs](https://duckduckgo.com/bang?q=), so I can use `!rust Iter` or `!crate
elefren` and it would translate the search for me, but if you don't use DDG
but code in Rust, it may be interesting.

# [Rust Survey 2019 Results](https://blog.rust-lang.org/2020/04/17/Rust-survey-2019.html)

In the end of last year, the Rust Core Team launched a survey asking how the
Rust developers feel about the language. The result is up.

It seems the general consensus for the language is "Some improvement" in most
of the areas.

# [Wiremock: async HTTP mocking to test Rust applications](https://www.lpalmieri.com/posts/2020-04-13-wiremock-async-http-mocking-for-rust-applications/)

A library for creating async web servers, to be used as mocks in tests. Looks
pretty cute.

# [clikan](https://github.com/kitplummer/clikan)

By the repo description: "clikan is a super simple personal kanban board that
runs in a CLI".

I'm a sucker for CLI tools, specially when they have a nice presentation
interface.

# ["It'll all be over by Christmas" (No it won't)](http://www.antipope.org/charlie/blog-static/2020/04/itll-all-be-over-by-christmas.html)

A good analysis of what's going on with the COVID lockdown, it's reflexes and
what is going on from here on.

Sure there is some speculation in the article, but even those are good food
for thought.

# [I've been writing TILs for 5 years](https://github.com/jbranchaud/til/blob/master/README.md)

A list of small things Josh Branchaud collected in 5 years, in different
topics.

---

This post was built with the help of

* [Adrian Cochrane](https://floss.social/@alcinnz)
* [HN Tooter](https://mastodon.social/@hntooter)
* [newsbot](https://mastodon.social/@newsbot)
* [Rust Brasil](https://t.me/rustlangbr)
