+++
title = "Commented Links for 2020-07-12"
date = 2020-07-12

[taxonomies]
tags = ["links", "erlang", "accessibility", "stackoverflow", "tests",
"flexbox", "http", "server", "c"]
+++

Erlang by Example, Accessibility, Good StackOverflow Answers, Testing,
Flexbox, HTTP Server in C, Icecream Affecting Cars.

<!-- more -->

## [Erlang/OTP by Example](http://erlangbyexample.org/)

Erlang is one of the languages in my "to learn" list and having a "by example"
site really helps -- at least, it helps me a lot with Rust.

## [The 6 Most Common Accessibility Problems (and How to Fix Them)](https://blog.scottlogic.com/2020/07/02/6-most-common-accessibility-problems.html)

Accessibility is always import. And knowing that there is something akin to
OWASP (common web application insecurities) that puts a list of common
problems is always good. And, on top of that, having a list of easy to fix
problems is even better.

## [Parsing city of origin / destination city from a string](https://stackoverflow.com/questions/59956670/parsing-city-of-origin-destination-city-from-a-string)

Although the answer is quite long and not "Just use X", this is the kind of
answer StackOverflow should aim for: Even if the question seems absurd, there
is a long explanation on how to do it, every step and problems on every step,
till the point of "it's not that simple".

## [against testing](https://flak.tedunangst.com/post/against-testing)

Someone took my words about testing and took it waaaay too far.

Sure, testing everything feels wrong, but you can see things are wrong when
someone says "Tests are very brittle, breaking due to entirely innocuous
changes in the code". Here is the problem: You're a fucking moron if that
happens; you're testing the _implementation_ not the _behavior_. So sure, it
will be brittle 'cause you wrote the whole thing wrong.

That is one of the points I really don't like the so called "unit test" -- as
in "testing every function". Behaviour is not contained in a function, but it
appears when functions interact. That's why integration tests feel more
"right" to me: We ignore how things were implemented and focus on how the
system should behave.

So yeah, testing is wrong and you may dislike it, specially when you writing
it wrong in the first place.

## [Coping with flexbox](https://kgrz.io/coping-with-flexbox.html)

Flexbox is in all rage these days in web development, mostly 'cause it fix the
damn "Center this vertically and horizontally". And this kind of explanation,
going through the basics, is always welcome.

## [httpserver.h:  Single header library for writing non-blocking HTTP servers in C](https://github.com/jeremycw/httpserver.h)

One of the weird things about C is that there is a lot you can do with it,
including a single file for building a whole HTTP server.

## ["My Car does not start when I buy Vanilla Ice Cream", said a Man to General Motors.](https://www.digitalrepublik.com/digital-marketing-newsletter/2015/05/10/my-car-does-not-start-when-i-buy-vanilla-ice-cream-said-a-man-to-general-motors/)

I'm a sucked for this kind of story: Things don't work because some weird
random, seemingly unrelated event.

It reminds me of the story "My password doesn't work when I'm standing up".
